#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dir.h>

int read_line(char *buf, FILE *fp);
int split_flds(char *str, char **flds, char delim, int skip, int maxflds);

int
main(int argc, char **argv)
{
	char buf[BUFSIZ], fname[BUFSIZ];
   char *flds[6];
   int nflds, nrecs, nalbs=0;
   FILE *ndxfp, *fp, *ofp;

   chdir("d:/albums");

   if ((ndxfp = fopen("albums.mst", "r")) == NULL)
   {
   	fprintf(stderr, "Can't open master file!\n");
      return 1;
   }

   if ((ofp = fopen("albpalm.txt", "w")) == NULL)
   {
   	fprintf(stderr, "Can't open output file!\n");
      return 2;
   }

   while (read_line(fname, ndxfp) == 0)
   {
   	nflds = split_flds(fname, flds, '|', 0, 3);
      if (nflds < 2) continue; /* invalid line */
   	fprintf(ofp, "* %s\n", fname); /* bookmark */
   	if ((fp = fopen(fname, "r")) == NULL)
      {
      	fprintf(stderr, "Can't open album file (%s)\n",
         	fname);
         continue;
      }
   	printf("Processing %s ...", fname);
      nrecs = 0;
      while (read_line(buf, fp) == 0)
      {
      	if (isspace(*buf)) continue; /* ignore tracks */
         nflds = split_flds(buf, flds, '|', 0, 6);
         if (nflds < 5) continue;
         fprintf(ofp, "%s\n\t%s\n",
         	flds[0], flds[1]);
         if (flds[2][0] == '\0') fprintf(ofp, "\t%s # %s\n",
         		flds[3], flds[4]);
         else fprintf(ofp, "\t[%s] %s # %s\n",
            flds[2], flds[3], flds[4]);
         nrecs++;
      }
      fclose(fp);
      printf(" %d albums\n", nrecs);
      nalbs += nrecs;
   }
   fclose(ofp);
   fclose(ndxfp);

   printf("%d albums total\n", nalbs);
   return 0;
}
