/*
 *				**** UPDATE SONGS ****
 *
 * This file contains routines that will update
 * the necessary song files (those that changed)
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>

#include "prodlist.h"
#include "alblist.h"

static char *Prog = "upd_song";

void
update_song_files(char *prog)
{
	int i, nsongs, updt;
   time_t old_time;
   struct song *song;
   char buf[BUFSIZ];
   struct stat sbuf;

	Prog = prog;

   /*
    * loop thru all known songs
    * check file times
    * if lyrics or description more recent, update
    * if list of albums changed, update
    * otherwise, leave alone
    */
   nsongs = get_number_songs(); /* how many songs? */
   for (i=0; i < nsongs; i++)
   { /* loop thru all files */
   	song = get_song_by_key_loc(i);
      updt = 0; /* assume don't update */
   	sprintf(buf, "songs/%s.html", song->key);
      if (stat(buf, &sbuf)) old_time = 0L;
      else old_time = sbuf.st_mtime;
      sprintf(buf, "sng/%s.html", song->key);
      if (stat(buf, &sbuf)) continue; /* no input file */
      if (old_time < sbuf.st_mtime)
      {
      	printf("Main file (%s) newer\n", buf);
      	updt++;
      }
      else if (song->lyrics)
      { /* lyrics there - see if newer */
      	sprintf(buf, "lyrics/%s.txt", song->key);
         if (stat(buf, &sbuf) == 0)
         { /* lyrics exist - check time */
         	if (old_time < sbuf.st_mtime)
            {
            	printf("Lyrics file (%s) newer\n", buf);
            	updt++;
            }
         }
      }
      if (!updt) if (is_song_alb_updated(song))
      {
      	printf("song/album changed for %s\n", song->title);
      	updt++;
      }

      /* if updt is true, create new page */
      if (updt)
		{
			printf("Song %s (%s) out of date.  Building ...\n",
   			song->key, song->title);
			build_song(song->key);
		}
   }
}

